# Generated by Django 3.2.3 on 2021-06-02 19:05

import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('accessory', '0001_initial'),
        ('assets', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='DataCenter',
            fields=[
                ('pkid', models.BigAutoField(editable=False, primary_key=True, serialize=False)),
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, unique=True, verbose_name='guid')),
                ('name', models.CharField(max_length=64, verbose_name='Verbose name')),
                ('location', models.CharField(max_length=256, verbose_name='Location of data center')),
            ],
            options={
                'ordering': ['name'],
            },
        ),
        migrations.CreateModel(
            name='Rack',
            fields=[
                ('pkid', models.BigAutoField(editable=False, primary_key=True, serialize=False)),
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, unique=True, verbose_name='guid')),
                ('name', models.CharField(max_length=64, verbose_name='Verbose name')),
                ('max_u_height', models.IntegerField(default=48)),
                ('orientation', models.PositiveIntegerField(choices=[(1, 'top'), (2, 'bottom'), (3, 'left'), (4, 'right')], default=1)),
                ('visualization_col', models.PositiveIntegerField(default=0, verbose_name='column number on visualization grid')),
                ('visualization_row', models.PositiveIntegerField(default=0, verbose_name='row number on visualization grid')),
            ],
        ),
        migrations.CreateModel(
            name='ServerRoom',
            fields=[
                ('pkid', models.BigAutoField(editable=False, primary_key=True, serialize=False)),
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, unique=True, verbose_name='guid')),
                ('name', models.CharField(max_length=64, verbose_name='Verbose name')),
                ('visualization_cols_num', models.PositiveIntegerField(default=20, validators=[django.core.validators.MinValueValidator(1), django.core.validators.MaxValueValidator(100)], verbose_name='visualization grid columns number')),
                ('visualization_rows_num', models.PositiveIntegerField(default=20, validators=[django.core.validators.MinValueValidator(1), django.core.validators.MaxValueValidator(100)], verbose_name='visualization grid rows number')),
                ('data_center', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datacenters.datacenter', to_field='id', verbose_name='data center')),
            ],
            options={
                'unique_together': {('name', 'data_center')},
            },
        ),
        migrations.CreateModel(
            name='RackAccessory',
            fields=[
                ('pkid', models.BigAutoField(editable=False, primary_key=True, serialize=False)),
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, unique=True, verbose_name='guid')),
                ('position', models.PositiveIntegerField(null=True)),
                ('orientation', models.PositiveIntegerField(choices=[(1, 'front'), (2, 'back'), (3, 'middle'), (101, 'left'), (102, 'right')], default=1)),
                ('remarks', models.CharField(blank=True, max_length=1024, verbose_name='Additional remarks')),
                ('accessory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='accessory.accessory', to_field='id')),
                ('rack', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datacenters.rack', to_field='id')),
            ],
            options={
                'verbose_name_plural': 'rack accessories',
            },
        ),
        migrations.AddField(
            model_name='rack',
            name='server_room',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='datacenters.serverroom', to_field='id', verbose_name='server room'),
        ),
        migrations.CreateModel(
            name='DataCenterAsset',
            fields=[
                ('pkid', models.BigAutoField(editable=False, primary_key=True, serialize=False)),
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, unique=True, verbose_name='guid')),
                ('status', models.PositiveIntegerField(choices=[(1, 'new'), (2, 'in use'), (3, 'free'), (4, 'damaged'), (5, 'liquidated')], default=1)),
                ('position', models.IntegerField(blank=True, null=True)),
                ('orientation', models.PositiveIntegerField(choices=[(1, 'front'), (2, 'back'), (3, 'middle'), (101, 'left'), (102, 'right')], default=1)),
                ('asset', models.OneToOneField(null=True, on_delete=django.db.models.deletion.CASCADE, to='assets.asset', to_field='id')),
                ('rack', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, to='datacenters.rack', to_field='id')),
            ],
            options={
                'verbose_name': 'data center asset',
                'verbose_name_plural': 'data center assets',
            },
        ),
        migrations.AlterUniqueTogether(
            name='rack',
            unique_together={('name', 'server_room')},
        ),
    ]
